package CSP.A202212.A3;

import java.util.Scanner;
/**
 * @Projectname: LeetCode
 * @Filename: CSP.A202212.A3.CSP.temp.A1.CSP.temp.A2.CSP.temp.A3.CSP.temp.A4.CSP.temp.A5.Main
 * @Author: 杨逸
 * @Data:2023/9/2 11:22
 * @Description: JPEG解码-第三题
 */
public class Main {
    //使用静态代码快初始化扫描数的索引位置
    static {
        index = new int[][]{
                {0,0},
                {0,1},{1,0},
                {2,0},{1,1},{0,2},
                {0,3},{1,2},{2,1},{3,0},
                {4,0},{3,1},{2,2},{1,3},{0,4},
                {0,5},{1,4},{2,3},{3,2},{4,1},{5,0},
                {6,0},{5,1},{4,2},{3,3},{2,4},{1,5},{0,6},
                {0,7},{1,6},{2,5},{3,4},{4,3},{5,2},{6,1},{7,0},
                {7,1},{6,2},{5,3},{4,4},{3,5},{2,6},{1,7},
                {2,7},{3,6},{4,5},{5,4},{6,3},{7,2},
                {7,3},{6,4},{5,5},{4,6},{3,7},
                {4,7},{5,6},{6,5},{7,4},
                {7,5},{6,6},{5,7},
                {6,7},{7,6},
                {7,7}};
    }
    private final static Scanner input = new Scanner(System.in);
    private static int T;
    private static int[][] Q = new int[8][8];
    private static double[][] M = new double[8][8];
    private static int[][] index;

    public static void main(String[] args) {
        //量化矩阵Q
        for (int i = 0; i < 8; i++) {
            for (int j = 0; j < 8; j++) {
                Q[i][j] = input.nextInt();
            }
        }

        //扫描数个数
        int n = input.nextInt();
        //操作编号
        T = input.nextInt();
        //填充扫描数
        for (int i = 0; i < n; i++) {
            M[index[i][0]][index[i][1]] = input.nextDouble();
        }
        // T为0时
        if (T==0){
            printM();
            return;
        }

        //矩阵乘法
        for (int i = 0; i < 8; i++) {
            for (int j = 0; j < 8; j++) {
                M[i][j] = M[i][j]*Q[i][j];
            }
        }
        //T为1时
        if (T==1){
            printM();
            return;
        }
        //离散余弦变换
        double[][] t = new double[8][8];
        for (int i = 0; i < M.length; i++) {
            for (int j = 0; j < M[0].length; j++) {
                t[i][j] = cosParse(i,j);
            }
        }
        for (int i = 0; i < 8; i++) {
            for (int j = 0; j < 8; j++) {
                M[i][j] = t[i][j];
            }
        }
        //输出最后结果
        for (double[] doubles : M) {
            for (double v : doubles) {
                v = Math.round(v+128);
                if (v>255){
                    v = 255;
                }else if (v<0){
                    v = 0;
                }
                System.out.print((int)v+ " ");
            }
            System.out.println();
        }
    }

    //离散余弦变换
    private static double cosParse(int x,int y){
        double temp = 0;
        for (int i = 0; i < 8; i++) {
            for (int j = 0; j < 8; j++) {
                temp += f(i)*f(j)*M[i][j]*Math.cos(Math.PI/8*(x+0.5)*i)*Math.cos(Math.PI/8*(y+0.5)*j);
            }
        }
        return temp/4;
    }

    private static double f(int n){
        if (n==0){
            return Math.sqrt(0.5);
        }else {
            return 1;
        }
    }

    private static void printM(){
        for (double[] doubles : M) {
            for (double v : doubles) {
                System.out.print((int)(v) + " ");
            }
            System.out.println();
        }
    }
}
//16 11 10 16 24 40 51 61
//        12 12 14 19 26 58 60 55
//        14 13 16 24 40 57 69 56
//        14 17 22 29 51 87 80 62
//        18 22 37 56 68 109 103 77
//        24 35 55 64 81 104 113 92
//        49 64 78 87 103 121 120 101
//        72 92 95 98 112 100 103 99
//        26
//        1
//        -26 -3 0 -3 -2 -6 2 -4 1 -3 1 1 5 1 2 -1 1 -1 2 0 0 0 0 0 -1 -1