package CSP.temp.A3;

import java.util.*;

/**
 * @Projectname: LeetCode
 * @Filename: CSP.temp.A3.CSP.temp.A4.CSP.temp.A5.Main
 * @Author: 杨逸
 * @Data:2023/9/2 13:52
 * @Description: U129675 移动盒子
 */
public class Main {
    private final static Scanner input = new Scanner(System.in);
    private static List<Stack<Integer>> result = new ArrayList<>();
    private static int n;
    private static int m;
    public static void main(String[] args) {
        //盒子个数
        n = input.nextInt();
        m = input.nextInt();
        //使用栈保存每个位置盒子的摆放
        for (int i = 0; i < n; i++) {
            //初始化盒子的位置
            Stack<Integer> queue = new Stack<>();
            queue.push(i);
            result.add(queue);
        }
        //执行操作
        for (int i = 0; i < m; i++) {
            int operate = input.nextInt();
            int x = input.nextInt();
            int y = input.nextInt();

            //判断是否需要进行下一步
            if (!isOk(x,y))continue;
            if (operate==1){
                //操作1
                //将盒子归位,放到原本的位置上
               reset(x,y);
               reset(y,x);

                //获得y所在的位置
                Stack<Integer> stackY = getStack(y);
                //获得x所在的位置
                Stack<Integer> stackX = getStack(x);
                //将x放的y上
                stackY.push(stackX.pop());
            }else if (operate==2){
                //操作2
                //将x的盒子归位
                reset(x,y);

                //获得y所在的位置
                Stack<Integer> stackY = getStack(y);
                //获得x所在的位置
                Stack<Integer> stackX = getStack(x);
                //将x放到y的顶部
                stackY.push(stackX.pop());
            }else if (operate==3){
                //操作三
                //将y归位
                reset(y,x);

                //获得y所在的位置
                Stack<Integer> stackY = getStack(y);
                //获得x所在的位置
                Stack<Integer> stackX = getStack(x);

                //将x及x上面的盒子放到一个临时的栈中
                Deque<Integer> stack = new LinkedList<>();
                while(!stackX.isEmpty()){
                    Integer val = stackX.pop();
                    stack.push(val);
                    if (val==x)break;
                }

                //将x上的所有盒子放到y上面
                while(!stack.isEmpty()){
                    stackY.push(stack.pop());
                }
            }else {
                //操作4
                //获得y所在的位置
                Stack<Integer> stackY = getStack(y);
                //获得x所在的位置
                Stack<Integer> stackX = getStack(x);

                //将x及x上面的盒子放到一个临时的栈中
                Stack<Integer> stack = new Stack<>();
                while(!stackX.isEmpty()){
                    Integer val = stackX.pop();
                    stack.push(val);
                    if (val==x)break;
                }

                //将x所有盒子放到y上面
                //将x上的所有盒子放到y上面
                while(!stack.isEmpty()){
                    stackY.push(stack.pop());
                }
            }
        }

        //打印结果
        for (int i = 0; i < result.size(); i++) {
            System.out.print(i +": ");
            for (Integer integer : result.get(i)) {
                System.out.print(integer + " ");
            }
            System.out.println();
        }

    }

    //盒子归位
    private static void reset(int x,int y){
        //x上方的盒子归位

        //找到x盒子在的位置
        Stack<Integer> queue = null;
        for (Stack<Integer> integers : result) {
            if (integers.contains(Integer.valueOf(x)) && integers.contains(Integer.valueOf(y))){
                return;
            }else if (integers.contains(Integer.valueOf(x))){
                queue = integers;
                break;
            }
        }

        //开始归位
        while(queue.peek()!= x){
            Integer val = queue.pop();
            result.get(val).push(val);
        }

    }

    //返回盒子n所在的位置
    private static Stack<Integer> getStack(int n){
        Stack<Integer> stack = null;
        for (Stack<Integer> integers : result) {
            if (integers.contains(Integer.valueOf(n))){
                stack = integers;
                break;
            }
        }
        return stack;
    }

    //判断x和y是否不在同一个位置
    private static boolean isOk(int x,int y){
        for (Stack<Integer> integers : result) {
            if (integers.contains(Integer.valueOf(x)) && integers.contains(Integer.valueOf(y))){
                return false;
            }
        }
        return true;
    }

}
