package leetcode.p2981;

import java.util.HashMap;
import java.util.Objects;

/**
 * @see <a href='https://leetcode.cn/problems/find-longest-special-substring-that-occurs-thrice-i/'>2981. 找出出现至少三次的最长特殊子字符串 I</a>
 * @ProjectName: LeetCode
 * @FileName: Solution
 * @Author: 杨逸
 * @Data:2024/5/29 10:07
 * @Description:
 * 给你一个仅由小写英文字母组成的字符串 s 。
 *
 * 如果一个字符串仅由单一字符组成，那么它被称为 特殊 字符串。例如，字符串 "abc" 不是特殊字符串，而字符串 "ddd"、"zz" 和 "f" 是特殊字符串。
 *
 * 返回在 s 中出现 至少三次 的 最长特殊子字符串 的长度，如果不存在出现至少三次的特殊子字符串，则返回 -1 。
 *
 * 子字符串 是字符串中的一个连续 非空 字符序列。
 *
 *
 *
 * 示例 1：
 *
 * 输入：s = "aaaa"
 * 输出：2
 * 解释：出现三次的最长特殊子字符串是 "aa" ：子字符串 "aaaa"、"aaaa" 和 "aaaa"。
 * 可以证明最大长度是 2 。
 * 示例 2：
 *
 * 输入：s = "abcdef"
 * 输出：-1
 * 解释：不存在出现至少三次的特殊子字符串。因此返回 -1 。
 * 示例 3：
 *
 * 输入：s = "abcaba"
 * 输出：1
 * 解释：出现三次的最长特殊子字符串是 "a" ：子字符串 "abcaba"、"abcaba" 和 "abcaba"。
 * 可以证明最大长度是 1 。
 *
 *
 * 提示：
 *
 * 3 <= s.length <= 50
 * s 仅由小写英文字母组成。
 */
public class Solution {
    public int maximumLength(String s) {
        HashMap<String, Integer> map = new HashMap<>();
        int d = s.length()-2;
        while (d>0){
            for (int i = 0; i <= s.length()-d; i++) {
                String key = s.substring(i, i + d);
                if (isOk(key)) map.put(key,map.getOrDefault(key,0)+1);
                //至少出现三次
                Integer integer = map.get(key);
                if (Objects.nonNull(integer) && integer >=3) {
                    return key.length();
                }
            }
            d--;
        }

        return -1;
    }

    private boolean isOk(String s){
        char c  = s.charAt(0);
        for (int i = 0; i < s.length(); i++) {
            if (c != s.charAt(i))return false;
        }
        return true;
    }
}
